#-*- mode: python; mode: fold -*-
##parameters=
# $Id: getWAeUPTypes.py 49 2005-10-16 16:09:41Z joachim $
"""Return custom document types."""
# permissions
from Products.CMFCore.permissions import View
from Products.CMFCore.permissions import ModifyPortalContent
from Products.CMFCore.permissions import AddPortalContent
ChangePermissions = 'Change permissions'

university_type = { ###(
    'title': 'WAeUP Base Folder',
    'description': 'The WAeUP Container',
    'content_icon': 'students_folder.gif',
    'content_meta_type': 'University',
    'product': 'WAeUP',
    'factory': 'addUniversity',
    'immediate_view': 'folder_view',
    'global_allow': 1,
    'filter_content_types': 1,
    'allowed_content_types': ('StudentsFolder'),
    'allow_discussion': 0,
    'cps_is_searchable': 1,
    'cps_display_as_document_in_listing': 1,
    'cps_proxy_type': 'folder',
    'schemas': ['metadata', 'common', 'folder'],
    'layouts': ['waeup_common', 'folder'],
    'layout_clusters': ['metadata:metadata'],
    'cps_section_wf': 'waeup_section_wf',
    'actions': ({'id': 'view',
                 'name': 'action_view',
                 'action': 'folder_view',
                 'permissions': (View,)},
                {'id': 'new_content',
                 'name': 'action_new_content',
                 'action': 'folder_factories',
                 'permissions': (AddPortalContent,)},
                {'id': 'contents',
                 'name': 'action_folder_contents',
                 'action': 'folder_contents',
                 'permissions': (ModifyPortalContent,)},
                {'id': 'edit',
                 'name': 'action_edit',
                 'action': 'cpsdocument_edit_form',
                 'permissions': (ModifyPortalContent,)},
                {'id': 'metadata',
                 'name': 'action_metadata',
                 'action': 'cpsdocument_metadata',
                 'condition': 'not:portal/portal_membership/isAnonymousUser',
                 'permissions': (View,)},
                {'id': 'localroles',
                 'name': 'action_local_roles',
                 'action': 'folder_localrole_form',
                 'permissions': (ChangePermissions,)},
    )
}

###)

students_folder_type = { ###(
    'title': 'WAeUP Student Folder',
    'description': 'The WAeUP Student Folder',
    'content_icon': 'students_folder.gif',
    'content_meta_type': 'StudentsFolder',
    'product': 'WAeUP',
    'factory': 'addStudentsFolder',
    'immediate_view': 'folder_view',
    'global_allow': 1,
    'filter_content_types': 1,
    'allowed_content_types': ('Student'),
    #'allowed_content_types': ('Student','ScratchCard'),
    'allow_discussion': 0,
    'cps_is_searchable': 1,
    'cps_display_as_document_in_listing': 1,
    'cps_proxy_type': 'folder',
    'schemas': ['metadata', 'common', 'folder'],
    'layouts': ['waeup_common','folder'],
    'layout_clusters': ['metadata:metadata'],
    'cps_section_wf': 'waeup_section_wf',
    'actions': ({'id': 'view',
                 'name': 'action_view',
                 'action': 'student_folder_view',
                 'permissions': (View,)},
                {'id': 'new_content',
                 'name': 'action_new_content',
                 'action': 'folder_factories',
                 'permissions': (AddPortalContent,)},
                {'id': 'contents',
                 'name': 'action_folder_contents',
                 'action': 'folder_contents',
                 'permissions': (ModifyPortalContent,)},
                {'id': 'edit',
                 'name': 'action_edit',
                 'action': 'cpsdocument_edit_form',
                 'permissions': (ModifyPortalContent,)},
                {'id': 'metadata',
                 'name': 'action_metadata',
                 'action': 'cpsdocument_metadata',
                 'condition': 'not:portal/portal_membership/isAnonymousUser',
                 'permissions': (View,)},
                {'id': 'localroles',
                 'name': 'action_local_roles',
                 'action': 'folder_localrole_form',
                 'permissions': (ChangePermissions,)},
    )
}

###)

student_type = { ###(
    'title': 'WAeUP Student',
    'description': '',
    'content_icon': 'student.gif',
    'content_meta_type': 'Student',
    'product': 'CPSDocument',
    'factory': 'addCPSDocument',
    'immediate_view': 'cpsdocument_view',
    #'product': 'WAeUP',
    #'factory': 'addStudent',
    #'immediate_view': 'student_view',
    'global_allow': True,
    'filter_content_types': True,
    'allowed_content_types': ('Jamb','StudentPersonal'),
    'allow_discussion': False,
    'cps_is_searchable': True,
    'cps_proxy_type': 'document',
    'cps_display_as_document_in_listing': True,
    'schemas': ['metadata','common','student'],
    'layouts': ['waeup_common','student'],
    'flexible_layouts': (),
    'layout_clusters': ['metadata:metadata'],
    'cps_workspace_wf': 'waeup_workspace_wf',
    'cps_section_wf': 'waeup_section_wf',
    'actions': (
         {'id': 'view',
          'name': 'action_view',
          'action': 'string:${object_url}/student_index_html',
          #'action': 'string:${object_url}/cpsdocument_view',
          'condition': '',
          'permission': ('View',),
          'category': 'object',
          'visible': True,},
         {'id': 'new_content',
          'name': 'Add Data',
          'action': 'string:${object_url}/folder_factories',
          'condition': "python:1 or len(object.contentItems()) == 0 ",
          'permission': ('Modify portal content',),
          'category': 'object',
          'visible': True,},
         {'id': 'contents',
          'name': 'action_folder_contents',
          'action': 'string:${object_url}/folder_contents',
          'condition': "python:1 or object.getTypeInfo().cps_proxy_type != 'document'",
          'permission': ('Modify portal content',),
          'category': 'object',
          'visible': True,},
         {'id': 'edit',
          'name': 'action_edit',
          'action': 'string:${object_url}/cpsdocument_edit_form',
          'condition': '',
          'permission': ('Modify portal content',),
          'category': 'object',
          'visible': True,},
    )
}

###)

scratch_card = { ###(
    'title': 'WAeUP Scratchcard',
    'description': '',
    'content_icon': 'student.gif',
    'content_meta_type': 'Scratch Card',
    'product': 'CPSDocument',
    'factory': 'addCPSDocument',
    'immediate_view': 'cpsdocument_view',
    'global_allow': True,
    'filter_content_types': True,
    'allowed_content_types': (),
    'allow_discussion': False,
    'cps_is_searchable': True,
    'cps_proxy_type': 'document',
    'cps_display_as_document_in_listing': True,
    'schemas': ('scratch_card'),
    'layouts': ('scratch_card'),
    'cps_workspace_wf': 'waeup_workspace_wf',
    'cps_section_wf': 'waeup_section_wf',
##    'actions': (
##         {'id': 'view',
##          'name': 'action_view',
##          'action': 'string:${object_url}/document_view',
##          'condition': '',
##          'permission': ('View',),
##          'category': 'object',
##          'visible': True,},
##         {'id': 'new_content',
##          'name': 'Add a scratch card',
##          'action': 'string:${object_url}/folder_factories',
##          'condition': "python:len(object.contentItems()) == 0 ",
##          'permission': ('Modify portal content',),
##          'category': 'object',
##          'visible': True,},
##         {'id': 'contents',
##          'name': 'action_folder_contents',
##          'action': 'string:${object_url}/folder_contents',
##          'condition': "python:object.getTypeInfo().cps_proxy_type != 'document'",
##          'permission': ('Modify portal content',),
##          'category': 'object',
##          'visible': True,},
##         {'id': 'edit',
##          'name': 'action_edit',
##          'action': 'string:${object_url}/cpsdocument_edit_form',
##          'condition': '',
##          'permission': ('Modify portal content',),
##          'category': 'object',
##          'visible': True,},
##    )
}
#
###)

jamb_type = { ###(
    'title': "JAMB data",
    'description': 'The data from JAMB',
    'content_icon': '',
    'content_meta_type': 'CPS Document',
    'product': 'CPSDocument',
    'factory': 'addCPSDocument',
    'immediate_view': 'cpsdocument_view',
    'global_allow': True,
    'filter_content_types': True,
    'allowed_content_types': (),
    'allow_discussion': False,
    'cps_is_searchable': True,
    'cps_proxy_type': 'document',
    'cps_display_as_document_in_listing': True,
    'cps_is_portalbox': False,
    #'schemas': ['common','metadata','jamb'],
    'schemas': ['jamb'],
    'layouts': ['jamb'],
    'flexible_layouts': (),
    'storage_methods': ('admitted:store_admission_pin'),
    'cps_workspace_wf': 'workspace_content_wf',
    'cps_section_wf': 'section_content_wf',
}

###)

student_personal_type = { ###(
    'title': "Student personal data",
    'description': '',
    'content_icon': '',
    'content_meta_type': 'CPS Document',
    'product': 'CPSDocument',
    'factory': 'addCPSDocument',
    'immediate_view': 'cpsdocument_view',
    'global_allow': True,
    'filter_content_types': True,
    'allowed_content_types': (),
    'allow_discussion': False,
    'cps_is_searchable': True,
    'cps_proxy_type': 'document',
    'cps_display_as_document_in_listing': True,
    'cps_is_portalbox': False,
    #'schemas': ['common','metadata','jamb'],
    'schemas': ['student_personal'],
    'layouts': ['student_personal'],
    'flexible_layouts': (),
    'storage_methods': (),
    'cps_workspace_wf': 'workspace_content_wf',
    'cps_section_wf': 'section_content_wf',
}
###)

types = {}
types['University'] = university_type
types['StudentsFolder'] = students_folder_type
types['Student'] = student_type
types['StudentPersonal'] = student_personal_type
types['ScratchCard'] = scratch_card
types['Jamb'] = jamb_type

return types

